package mo.dataprog.dataStructures;

/**
 * Class for represnting Pattern2s used in DataProg algorithm
 * Specific psattern will be represented by list of Pattern2 Class objects.
 * Main determinant of Patern will be the tokenType field. If the tokenType is of "specific" type
 * then the text field is used
 * @author Administrator
 *
 */
public class Pattern2
{
	
	
	TokenType tokenType;
	
	String text;
	
	/**
	 * Construcotr
	 * @param _tokenType
	 * @param _text
	 */
	public Pattern2(String _text)
	{
		tokenType = TokenType.SpecificType;
		text = _text;
	}
	
	public Pattern2(TokenType _tokenType)
	{
		tokenType = _tokenType;
		text = "";
	}

	//getters and setters
	public TokenType getTokenType()
	{
		return tokenType;
	}

	public void setTokenType(TokenType tokenType)
	{
		this.tokenType = tokenType;
	}

	public String getText()
	{
		return text;
	}

	public void setText(String text)
	{
		this.text = text;
	}
	
	/**
	 * Overriden method to return text. If the type is SpecificType then the string value is retruned.
	 * Otherwise token Value
	 */	
	public String toString()
	{
		return tokenType == TokenType.SpecificType ? text : tokenType.toString();
	}
	
 

	@Override
	public boolean equals(Object obj)
	{
		if (obj instanceof Pattern2)
		{
			Pattern2 p = (Pattern2)obj;
			if (p.getTokenType() != TokenType.SpecificType)
				return p.getTokenType() == this.tokenType;
			else
				return p.getText().equals(this.text);
		}
		else
			return super.equals(obj);
	}
	
	
	
	@Override
	public int hashCode()
	{
		if (this.tokenType != TokenType.SpecificType)
			return this.tokenType.hashCode();
		else
			return this.text.hashCode();
	}
}
