

package ibspan.tss.domain.ontology.restaurant;

import com.hp.hpl.jena.rdf.model.Resource;
import com.hp.hpl.jena.rdf.model.ResourceFactory;

/**
 * Interface for FeatureCode ontology class<br>
 * Use the ibspan.tss.domain.ontology.restaurant.RestaurantFactory to create instances of this interface.
 * <p>(URI: http://www.ibspan.waw.pl/tss/Restaurant#FeatureCode)</p>
 * <br>
 * <br>
 * <br>
 */
public interface FeatureCode extends com.ibm.adtech.jastor.Thing {
	
	/**
	 * The rdf:type for this ontology class
     */
	public static final Resource TYPE = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#FeatureCode");
	


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#Takeout
	 */
	public static com.hp.hpl.jena.rdf.model.Resource Takeout = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#Takeout");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#FineDining
	 */
	public static com.hp.hpl.jena.rdf.model.Resource FineDining = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#FineDining");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#BreakfastBuffet
	 */
	public static com.hp.hpl.jena.rdf.model.Resource BreakfastBuffet = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#BreakfastBuffet");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#FixedPriceMealsAtLunc
	 */
	public static com.hp.hpl.jena.rdf.model.Resource FixedPriceMealsAtLunc = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#FixedPriceMealsAtLunc");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#PrivateParties
	 */
	public static com.hp.hpl.jena.rdf.model.Resource PrivateParties = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#PrivateParties");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#SundayBrunch
	 */
	public static com.hp.hpl.jena.rdf.model.Resource SundayBrunch = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#SundayBrunch");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#Kids
	 */
	public static com.hp.hpl.jena.rdf.model.Resource Kids = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#Kids");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#LargePrintMenu
	 */
	public static com.hp.hpl.jena.rdf.model.Resource LargePrintMenu = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#LargePrintMenu");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#PrivateRoomAvailable
	 */
	public static com.hp.hpl.jena.rdf.model.Resource PrivateRoomAvailable = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#PrivateRoomAvailable");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#Kiosk
	 */
	public static com.hp.hpl.jena.rdf.model.Resource Kiosk = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#Kiosk");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#DinnerBuffet
	 */
	public static com.hp.hpl.jena.rdf.model.Resource DinnerBuffet = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#DinnerBuffet");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#FastFood
	 */
	public static com.hp.hpl.jena.rdf.model.Resource FastFood = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#FastFood");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#LargeGroupsOk
	 */
	public static com.hp.hpl.jena.rdf.model.Resource LargeGroupsOk = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#LargeGroupsOk");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#VegetarianMenu
	 */
	public static com.hp.hpl.jena.rdf.model.Resource VegetarianMenu = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#VegetarianMenu");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#NiceView
	 */
	public static com.hp.hpl.jena.rdf.model.Resource NiceView = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#NiceView");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#Brewery
	 */
	public static com.hp.hpl.jena.rdf.model.Resource Brewery = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#Brewery");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#Halal
	 */
	public static com.hp.hpl.jena.rdf.model.Resource Halal = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#Halal");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#Upscale
	 */
	public static com.hp.hpl.jena.rdf.model.Resource Upscale = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#Upscale");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#FixedPriceMealsAtDinn
	 */
	public static com.hp.hpl.jena.rdf.model.Resource FixedPriceMealsAtDinn = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#FixedPriceMealsAtDinn");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#BeingYourOwnWine
	 */
	public static com.hp.hpl.jena.rdf.model.Resource BeingYourOwnWine = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#BeingYourOwnWine");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#Outdoor
	 */
	public static com.hp.hpl.jena.rdf.model.Resource Outdoor = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#Outdoor");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#ExtensiveWineList
	 */
	public static com.hp.hpl.jena.rdf.model.Resource ExtensiveWineList = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#ExtensiveWineList");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#PhoneAheadSeating
	 */
	public static com.hp.hpl.jena.rdf.model.Resource PhoneAheadSeating = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#PhoneAheadSeating");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#Cafeteria
	 */
	public static com.hp.hpl.jena.rdf.model.Resource Cafeteria = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#Cafeteria");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#WineTasting
	 */
	public static com.hp.hpl.jena.rdf.model.Resource WineTasting = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#WineTasting");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#Beverage
	 */
	public static com.hp.hpl.jena.rdf.model.Resource Beverage = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#Beverage");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#VeganDishes
	 */
	public static com.hp.hpl.jena.rdf.model.Resource VeganDishes = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#VeganDishes");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#Fireplace
	 */
	public static com.hp.hpl.jena.rdf.model.Resource Fireplace = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#Fireplace");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#WineList
	 */
	public static com.hp.hpl.jena.rdf.model.Resource WineList = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#WineList");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#CertifiedKosher
	 */
	public static com.hp.hpl.jena.rdf.model.Resource CertifiedKosher = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#CertifiedKosher");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#SaladBar
	 */
	public static com.hp.hpl.jena.rdf.model.Resource SaladBar = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#SaladBar");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#AdultEntertainment
	 */
	public static com.hp.hpl.jena.rdf.model.Resource AdultEntertainment = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#AdultEntertainment");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#DriveThrough
	 */
	public static com.hp.hpl.jena.rdf.model.Resource DriveThrough = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#DriveThrough");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#SenorMenu
	 */
	public static com.hp.hpl.jena.rdf.model.Resource SenorMenu = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#SenorMenu");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#BeingYourOwnBeer
	 */
	public static com.hp.hpl.jena.rdf.model.Resource BeingYourOwnBeer = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#BeingYourOwnBeer");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#BrailleMenu
	 */
	public static com.hp.hpl.jena.rdf.model.Resource BrailleMenu = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#BrailleMenu");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#MinorsNotAllowed
	 */
	public static com.hp.hpl.jena.rdf.model.Resource MinorsNotAllowed = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#MinorsNotAllowed");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#Entertainment
	 */
	public static com.hp.hpl.jena.rdf.model.Resource Entertainment = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#Entertainment");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#AllPurpose
	 */
	public static com.hp.hpl.jena.rdf.model.Resource AllPurpose = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#AllPurpose");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#Casual
	 */
	public static com.hp.hpl.jena.rdf.model.Resource Casual = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#Casual");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#OffsiteCatering
	 */
	public static com.hp.hpl.jena.rdf.model.Resource OffsiteCatering = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#OffsiteCatering");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#VegetarianDishes
	 */
	public static com.hp.hpl.jena.rdf.model.Resource VegetarianDishes = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#VegetarianDishes");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#Winery
	 */
	public static com.hp.hpl.jena.rdf.model.Resource Winery = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#Winery");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#InternetAccess
	 */
	public static com.hp.hpl.jena.rdf.model.Resource InternetAccess = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#InternetAccess");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#EnglishLanguageMenu
	 */
	public static com.hp.hpl.jena.rdf.model.Resource EnglishLanguageMenu = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#EnglishLanguageMenu");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#Cafe
	 */
	public static com.hp.hpl.jena.rdf.model.Resource Cafe = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#Cafe");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#Buffet
	 */
	public static com.hp.hpl.jena.rdf.model.Resource Buffet = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#Buffet");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#LunchBuffet
	 */
	public static com.hp.hpl.jena.rdf.model.Resource LunchBuffet = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#LunchBuffet");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#Family
	 */
	public static com.hp.hpl.jena.rdf.model.Resource Family = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#Family");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#KidFriendly
	 */
	public static com.hp.hpl.jena.rdf.model.Resource KidFriendly = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#KidFriendly");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#VeganMenu
	 */
	public static com.hp.hpl.jena.rdf.model.Resource VeganMenu = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#VeganMenu");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#Delivery
	 */
	public static com.hp.hpl.jena.rdf.model.Resource Delivery = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#Delivery");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#Conservatory
	 */
	public static com.hp.hpl.jena.rdf.model.Resource Conservatory = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#Conservatory");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#TastingMenu
	 */
	public static com.hp.hpl.jena.rdf.model.Resource TastingMenu = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#TastingMenu");


	/**
	 * Individual for URI: http://www.ibspan.waw.pl/tss/Restaurant#BeerTasting
	 */
	public static com.hp.hpl.jena.rdf.model.Resource BeerTasting = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/Restaurant#BeerTasting");





}