package semfly.agents.behaviours;

import semfly.agents.SystemGUIAgent;
import jade.core.Agent;
import jade.core.behaviours.DataStore;
import jade.lang.acl.ACLMessage;
import jade.proto.SimpleAchieveREInitiator;

/**
 * @author Szymon Pisarek (szymekpi@o2.pl)
 *
 * This behaviour is responsible for sending requests to Coordinator Agent
 * and ReportingAgent.
 * The owner of this behaviour must be SystemGUIAgent.
 */
public class GUIAgentSender extends SimpleAchieveREInitiator
{
    /**
     * Request that is to be sent.
     */
    ACLMessage request;
    
    public GUIAgentSender(Agent agent, ACLMessage rq)
    {
        super(agent, rq);
        
        assert agent instanceof SystemGUIAgent;
        request = rq;
    }

    public GUIAgentSender(Agent agent, ACLMessage rq, DataStore ds)
    {
        super(agent, rq, ds);
        
        assert agent instanceof SystemGUIAgent;
        request = rq;
    }

    protected void handleRefuse(ACLMessage msg)
    {
        ((SystemGUIAgent)myAgent).addSenderBehaviour(request);
    }
    
    protected void handleInform(ACLMessage msg)
    {
        ((SystemGUIAgent)myAgent).commitSuicide();
    }
}
