package semfly.agents.behaviours;

import semfly.agents.IndexingAgent;
import semfly.agents.WrapperAgent;
import semfly.globals.CCSVocabulary;
import jade.core.behaviours.CyclicBehaviour;
import jade.lang.acl.ACLMessage;
import jade.core.Agent;
import jade.lang.acl.MessageTemplate;

/**
 * @author Szymon Pisarek (szymekpi@o2.pl)
 *
 * This class is responsible for receiving messages from CA.
 * This behaviour is used by Indexing Agents and Wrapper Agents.
 */
public class OrdersReceiver extends CyclicBehaviour
{
    public OrdersReceiver(Agent owner)
    {
        myAgent = owner;
    }
    
    public void action()
    {
        MessageTemplate mt =
            MessageTemplate.MatchPerformative(ACLMessage.REQUEST);
        ACLMessage orderMsg = myAgent.blockingReceive(mt);
        if (orderMsg != null)
        {
            if (orderMsg.getPerformative() != ACLMessage.REQUEST)
                System.out.println(orderMsg);
            
		    if (orderMsg.getContent().equals(CCSVocabulary.ORDER_2_DIE))
		    {
		        if (myAgent instanceof IndexingAgent)
		            ((IndexingAgent)myAgent).commitSuicide();
		        else if (myAgent instanceof WrapperAgent)
		            ((WrapperAgent)myAgent).commitSuicide();
		    }
        }
    }
}
