package semfly.db;

import semfly.exceptions.DBWriterException;
//import semfly.exceptions.ExceptionManager;
import com.hp.hpl.jena.db.DBConnection;
import com.hp.hpl.jena.db.IDBConnection;

/**
 * @author Szymon Pisarek (szymekpi@o2.pl)
 *
 * This class is a wrapper for DBWriter class. It is responsible for saving
 * tokens in a DB.
 */
public final class SemflyDBWriter extends DBWriter
{
    private final String DBDriverClassName = "com.mysql.jdbc.Driver";
    private final String DB_URL = "jdbc:mysql://localhost/semfly",  
    				DB_USER = "semUser", DB_PASSWD = "semPass", DB = "MySQL";   
    private final String DBModelName = "semflyDB";
    
    public SemflyDBWriter() throws DBWriterException
    {
        createDBConnection();
        setDBModelName(DBModelName);
    }
    
    private SemflyDBWriter(IDBConnection dbConn, String dbModelName)
    {
    }
    
    /**
     * Creates a DB connection.
     * @throws DBWriterException
     */
    private void createDBConnection() throws DBWriterException
    {
	    assert dbConn == null;
	    
	    try
	    {
	        Class.forName(DBDriverClassName);                      
	        dbConn = new DBConnection(DB_URL, DB_USER, DB_PASSWD, DB);
	    }
	    catch (ClassNotFoundException ex)
	    {
	        throw new DBWriterException("Unable to create DB connection", ex);
	    }
    }
}
