package semfly.dto;

/**
 * @author Szymon Pisarek (szymekpi@o2.pl)
 *
 * Describes a hotel's location: a code of the country the hotel is located in
 * or a code of the state when the hotel is located in the USA
 */
public class HotelLocation
{
    public final static int Country = 1, USState = 2;
    
    protected String locationCode;
    protected int locationType;
    
    public HotelLocation(String locCode, int locType)
    { 
        setLocationCode(locCode);
        setLocationType(locType);
    }
    
    public boolean isLocatedInCountry()
    {
        return locationType == Country;
    }
    
    public boolean isLocatedInUSState()
    {
        return locationType == USState;
    }
    
    /**
     * @return Returns the locationCode.
     */
    public String getLocationCode()
    {
        return locationCode;
    }
    
    /**
     * @return Returns the locationType.
     */
    public int getLocationType()
    {
        return locationType;
    }
    /**
     * @param locationCode The locationCode to set.
     */
    protected void setLocationCode(String locCode)
    {
        assert locCode != null;
        
        locationCode = locCode;
    }
    
    /**
     * @param locationType The locationType to set.
     */
    protected void setLocationType(int locType)
    {
        assert locType == Country || locType == USState;
        
        locationType = locType;
    }
}
