package semfly.exceptions;

import jade.core.AID;

/**
 * @author Szymon Pisarek (szymekpi@o2.pl)
 *
 * This kind of exception is thrown when any kind of exception is thrown
 * inside method that is responsible for parsing data.
 */
public class WebSourceParseException extends WrapperException
{

    /**
     * @param agent
     * @param webSourceAddr
     */
    public WebSourceParseException(AID agent, String webSourceAddr)
    {
        super(agent, webSourceAddr);
    }

    /**
     * @param agent
     * @param webSourceAddr
     * @param message
     */
    public WebSourceParseException(AID agent, String webSourceAddr,
            String message)
    {
        super(agent, webSourceAddr, message);
    }

    /**
     * @param agent
     * @param message
     * @param innerEx
     * @param webSourceAddr
     */
    public WebSourceParseException(AID agent, String message,
            Throwable innerEx, String webSourceAddr)
    {
        super(agent, message, innerEx, webSourceAddr);
    }
    
    public WebSourceParseException(AID agent, String message,
            Throwable innerEx)
    {
        super(agent, message, innerEx);
    }
}
