package semfly.log;

import org.apache.log4j.Logger;

/**
 * @author Szymon Pisarek (szymekpi@o2.pl)
 *
 * This class is responsible for writing messages to file log.
 */
public class LogWriter
{
    private final static String FilePath = "CCSLog.txt";
    
    private LogWriter(){}
    
    /**
     * Writes the message (msg) given including information from the 
     * object (obj) given to the CCS log with WARN priority.
     */
    public static void writeWarn2Log(String category, String msg, Object obj)
    {
        if (category == null) 
	        throw new IllegalArgumentException("Category can't be null");
	    if (msg == null) throw new 
			IllegalArgumentException("Message to publish can't be null");
	    if (obj == null) throw new 
			IllegalArgumentException("Object to publish can't be null");
        
        Logger logger = Logger.getLogger(category);
		logger.warn(msg + "\nEXTRA OBJECT: " + obj);
    }
    
    /**
     * Writes the message (msg) given including information from the 
     * object (obj) given to the CCS log with WARN priority.
     */
    public static void writeWarn2Log(String category, String msg)
    {
        if (category == null) 
	        throw new IllegalArgumentException("Category can't be null");
	    if (msg == null) throw new 
			IllegalArgumentException("Message to publish can't be null");
        
        Logger logger = Logger.getLogger(category);
		logger.warn(msg);
    }
    
    /**
     * Writes the message (msg) given to the CCS log with ERROR priority.
     */
    public static void writeError2Log(String msg)
    {
       if (msg == null) throw new 
			IllegalArgumentException("Message to publish can't be null");
        
        Logger logger = Logger.getLogger("ERROR");
		logger.error(msg);
    }
    
    /**
     * Writes the message (msg) given including information from the 
     * object (obj) given to the CCS log with ERROR priority.
     */
    public static void writeError2Log(String category, String msg, Object obj)
    {
        if (category == null) 
	        throw new IllegalArgumentException("Category can't be null");
	    if (msg == null) throw new 
			IllegalArgumentException("Message to publish can't be null");
	    if (obj == null) throw new 
			IllegalArgumentException("Object to publish can't be null");
        
        Logger logger = Logger.getLogger(category);
		logger.error(msg + "\nEXTRA OBJECT: " + obj);
    }
}
