package semfly.onto.jade;

import jade.content.ContentElement;
import jade.core.*;
import java.util.Date;
import java.lang.StringBuffer;

/**
 * @author Szymon Pisarek (szymekpi@o2.pl)
 * 
 * This is a DTO (Data Transfer Object) based on IndexToken ontology.
*/
public class IndexToken extends Token implements Comparable, ContentElement
{
   /**
   * Protege name: jenaModel
   */
   private String jenaModel;
   public void setJenaModel(String value) { 
    this.jenaModel=value;
   }
   public String getJenaModel() {
     return this.jenaModel;
   }

   /**
   * Protege name: tokenPriority
   */
   private int tokenPriority;
   public void setTokenPriority(int value) { 
    this.tokenPriority=value;
   }
   public int getTokenPriority() {
     return this.tokenPriority;
   }

   /**
   * Protege name: createdBy
   */
   private AID createdBy;
   public void setCreatedBy(AID value) { 
    this.createdBy=value;
   }
   public AID getCreatedBy() {
     return this.createdBy;
   }

   /**
   * Protege name: createdDate
   */
   private Date createdDate;
   public void setCreatedDate(Date value) { 
    this.createdDate=value;
   }
   public Date getCreatedDate() {
     return this.createdDate;
   }

   /**
    * Compares objects.
    * IndexToken with bigger value of 'tokenPriority' field is in fact smaller.
    * This way tokens with the biggest 'tokenPriority' values are first in
    * priority queue (CoordinatorAgent's Tokens Priority Queue).
    */
   public int compareTo(Object obj)
   {
       if (obj == null) 
           throw new NullPointerException("obj to compare can't be null");
       
       if (obj instanceof IndexToken)
       {
           IndexToken token = (IndexToken)obj;
           if (this.tokenPriority > token.tokenPriority) return -1;
           if (this.tokenPriority < token.tokenPriority) return 1;
           
           return 0;
       }
       
       throw new ClassCastException("obj is not an IndexToken");
   }
   
   public String toString()
   {
       StringBuffer buf = new StringBuffer();
       
       buf.append("TOKEN PRIORITY: ");
       buf.append(tokenPriority);
       
       buf.append("|CREATED BY: ");
       buf.append(createdBy.toString());
       
       buf.append("|CREATED DATE: ");
       buf.append(createdDate.toString());
       
       buf.append("|JENA MODEL: ");
       buf.append(jenaModel);
       
       return buf.toString();
   }
}
