package semfly.textmining;

import java.lang.StringBuffer;
/**
 * @author Szymon Pisarek (szymekpi@o2.pl)
 *
 * Helper class for extracting e.g. numbers, parsing string, etc.
 */
public class StringHelper
{
    private static StringHelper stringHelper;
    
    private StringHelper()
    {
    }
    
    public static StringHelper getInstance()
    {
        if (stringHelper == null)
        {
            stringHelper = new StringHelper();
        }
        return stringHelper;
    }
    
    public Long extractPrefixNumber(String text)
    {
        StringBuffer buf = new StringBuffer();
        char c;
        for (int i = 0; i < text.length(); i++)
        {
            c = text.charAt(i);
            if ( Character.isDigit(c) )
            {
                buf.append(c);
            }
        }
        
        if (buf.length() > 0)
        {
            return new Long(buf.toString());
        }
        
        return null;
    }
    
    public String extractPrefixLocality(String text)
    {
        StringBuffer buf = new StringBuffer();
        char c;
        for (int i = 0; i < text.length(); i++)
        {
            c = text.charAt(i);
            if ( !Character.isDigit(c) )
            {
                buf.append(c);
            }
            else break;
        }
        
        return buf.toString().trim();
    }
    
    public String extractSufixPostCode(String text)
    {
        StringBuffer buf = new StringBuffer();
        char c;
        for (int i = 0; i < text.length(); i++)
        {
            c = text.charAt(i);
            if ( Character.isDigit(c) )
            {
                buf.append(c);
            }
        }
        
        return buf.toString().trim();
    }
}
